/*	tr.im widget
	Andrew Hedges, andrew@hedges.name
	Version 1.1, 16 November 2008
*/
(function () {
	var
		browsers,
		apiURL,
		command,
		browser,
		onshow,
		getURL,
		trimURL,
		localize,
		init
	;
	
	browsers = ['Safari', 'Firefox', 'Camino', 'Opera', 'Flock', 'OmniWeb'];
	apiURL   = 'http://tr.im/api/trim_url.json?api_key=qORRKUoCiL14o75ifgJVSVgkql5wPhWVQ6s8KxxTWgRlcd8R&url=';
	command  = 'ps xww | grep ';
	
	onshow = function () {
		isActivated();
	};
	
	isActivated = function () {
		var cmd;
		cmd = widget.system(command + browser, function (obj) {
			if (obj.outputString.indexOf(browser + '.app') > -1) {
				getURL();
			} else {
				$('input[name=url]').val('');
			}
		});
	};
	
	getURL = function () {
		widget.system('assets/getURL-' + browser + '.sh', function (obj) {
			var url;
			url = obj.outputString.length < 5 ? 'http://andrew.hedges.name/widgets/' : obj.outputString;
			$('input[name=url]').val(url);
		});
	};
	
	trimURL = function () {
		$.ajax({
			url      : apiURL + encodeURIComponent($('input[name=url]').val()),
			method   : 'get',
			dataType : 'json',
			success  : function (json) {
				var url;
				url = 'ERROR' === json.status['result'] ? json.status.message: json.url;
				$('input[name=url]').val(url);
				widget.system("/bin/echo -n '" + url + "' | /usr/bin/pbcopy", function () {});
			}
		});
	};
	
	localize = function (str) {
		try {
			var str = LocalizedStrings[str] || str;
		} catch (e) {}
		return str;
	};
	
	getKey = function (key) {
		return widget.idenfifier + key;
	};
	
	getPref = function (key) {
		return widget.preferenceForKey(getKey(key));
	};
	
	setPref = function (key, val) {
		widget.setPreferenceForKey(val, getKey(key));
	};
	
	updateBrowserButton = function () {
		$('#button-browser img').attr('src', 'assets/icons/' + browser + '.png');
	};
	
	$(function () {
		var trimit;
		trimit  = new AppleGlassButton(document.getElementById('button-go'), localize('Trim It'), trimURL);
		browser = getPref('browser');
		if ('undefined' === typeof browser) {
			browser = browsers[0];
			setPref('browser', browser);
		}
		$('#button-browser')
			.mousedown(function (evt) {
				$(this).css({
					'background-image' : 'url(assets/button-clicked.png)'
				});
			})
			.mouseup(function (evt) {
				$(this).css({
					'background-image' : 'url(assets/button.png)'
				});
			})
			.click(function (evt) {
				var pos;
				pos = $.inArray(browser, browsers);
				evt.shiftKey ? --pos : ++pos;
				if (pos < 0) pos = browsers.length - 1;
				if (pos > browsers.length - 1) pos = 0;
				browser = browsers[pos];
				setPref('browser', browser);
				updateBrowserButton();
				isActivated();
			})
		;
		updateBrowserButton();
		isActivated();
		widget.onshow = onshow;
	});
})();